package com.example.tbadapter;

import android.app.Activity;
import android.util.Log;

import com.open.ad.polyunion.bean.CAdInfo;
import com.open.ad.polyunion.listener.RewardVideoListener;
import com.open.ad.polyunion.view.AdConfig;
import com.open.ad.polyunion.view.AdRequestConfig;
import com.open.ad.polyunion.view.AdView;
import com.windmill.sdk.WMConstants;
import com.windmill.sdk.base.WMAdapterError;
import com.windmill.sdk.custom.WMCustomRewardAdapter;
import com.windmill.sdk.models.BidPrice;

import java.util.HashMap;
import java.util.Map;

public class CloooudCustomRewardVideo extends WMCustomRewardAdapter {

    private AdView rewardVideo;
    private boolean isReady = false;

    @Override
    public void loadAd(Activity activity, Map<String, Object> serverExtra, Map<String, Object> map1) {
        String codeId = (String) map1.get(WMConstants.PLACEMENT_ID);
        AdRequestConfig requestConfig = new AdRequestConfig.Builder()
                .AdType(AdConfig.AD_TYPE_REWARDVIDEO)
                .requestTimeOutMillis(10000) //设置聚合SDK请求前超时时间，毫秒
                .slotId(codeId) //广告场景id
                .build();
        rewardVideo = new AdView(activity, requestConfig);
        rewardVideo.setRewardVideoListener(new RewardVideoListener() {

            @Override
            public void onAdFailed(String msg) {
                callLoadFail(new WMAdapterError(9999, msg));
            }

            @Override
            public void onVideoComplete() {
                callVideoAdPlayComplete();
            }

            @Override
            public void onAdReward() {
                callVideoAdReward(true);
            }

            @Override
            public void onAdClose() {
                callVideoAdClosed();
            }

            @Override
            public void onAdReady(int price) {
                isReady = true;
                if (isClientBidding()) {
                    double ecpm = price;
                    if (ecpm < 0) {
                        ecpm = 0;
                    }
                    callLoadBiddingSuccess(new BidPrice(String.valueOf(ecpm)));
                } else {

                }
                callLoadSuccess();
            }

            @Override
            public void onVideoCached() {

            }

            @Override
            public void onAdShow(CAdInfo cAdInfo) {
                callVideoAdShow();
            }

            @Override
            public void onAdClick(String s) {
                callVideoAdClick();
            }
        });
    }


    public boolean isClientBidding() {
        return getBiddingType() == WMConstants.AD_TYPE_CLIENT_BIDING;
    }


    @Override
    public void showAd(Activity activity, HashMap<String, String> hashMap, Map<String, Object> map) {
        if (rewardVideo != null && rewardVideo.isRewardVideoOk()) {
            rewardVideo.showRewardVideoAd(activity);
        }
    }

    @Override
    public boolean isReady() {
        return isReady && rewardVideo != null;
    }

    @Override
    public void destroyAd() {
        if (rewardVideo != null) {
            rewardVideo.onDestroyAd();
        }
    }
}
