package com.example.tbadapter;

import android.app.Activity;
import android.util.Log;
import android.view.View;

import com.open.ad.polyunion.bean.CAdInfo;
import com.open.ad.polyunion.listener.AdViewListener;
import com.open.ad.polyunion.view.AdConfig;
import com.open.ad.polyunion.view.AdRequestConfig;
import com.open.ad.polyunion.view.AdView;
import com.windmill.sdk.WMConstants;
import com.windmill.sdk.base.WMAdapterError;
import com.windmill.sdk.custom.WMCustomBannerAdapter;
import com.windmill.sdk.models.BidPrice;

import org.json.JSONObject;

import java.util.Map;

public class CloooudCustomerBanner extends WMCustomBannerAdapter {
    private AdView mBannerView;
    private boolean isReady = false;

    @Override
    public void loadAd(Activity activity, Map<String, Object> serverExtra, Map<String, Object> map1) {

        String codeId = (String) map1.get(WMConstants.PLACEMENT_ID);//901121246
        int[] screenSizeDP = Util.getScreenSizeInDP(activity);
        AdRequestConfig requestConfig = new AdRequestConfig.Builder()
                .AdType(AdConfig.AD_TYPE_BANNER)
                .slotId(codeId) //广告场景id
                .widthDp(screenSizeDP[0]).heightDp(0)//0为自适应
                .bannerInterval(0)//轮播时间 默认0
                .requestTimeOutMillis(50000)
                .build();
        mBannerView = new AdView(activity, requestConfig);
        mBannerView.setListener(new AdViewListener() {
            @Override
            public void onAdClick() {
                callBannerAdClick();
            }

            @Override
            public void onAdFailed(String msg) {
                Log.e("Cloooud","错误："+msg);
                callLoadFail(new WMAdapterError(9999, msg));
            }

            @Override
            public void onAdReady(int price) {
                isReady = true;
                if (isClientBidding()) {
                    double ecpm = price;
                    if (ecpm < 0) {
                        ecpm = 0;
                    }
                    callLoadBiddingSuccess(new BidPrice(String.valueOf(ecpm)));
                } else {
                    callLoadSuccess();
                }
            }

            @Override
            public void onAdShow(CAdInfo cAdInfo) {
                callBannerAdShow();
            }

            @Override
            public void onAdDismissed(String s) {
                callBannerAdClosed();
            }
        });


    }

    public boolean isClientBidding() {
        return getBiddingType() == WMConstants.AD_TYPE_CLIENT_BIDING;
    }

    @Override
    public boolean isReady() {
        return isReady && mBannerView != null;
    }

    @Override
    public void destroyAd() {
        if (mBannerView == null) {
            return;
        }
        mBannerView.onDestroyAd();
    }

    @Override
    public View getBannerView() {
        return mBannerView;
    }
}
