package com.example.tbadapter;

import android.app.Activity;

import com.open.ad.polyunion.bean.CAdInfo;
import com.open.ad.polyunion.listener.AdViewListener;
import com.open.ad.polyunion.view.AdConfig;
import com.open.ad.polyunion.view.AdRequestConfig;
import com.open.ad.polyunion.view.AdView;
import com.windmill.sdk.WMConstants;
import com.windmill.sdk.base.WMAdapterError;
import com.windmill.sdk.custom.WMCustomInterstitialAdapter;
import com.windmill.sdk.models.BidPrice;

import java.util.HashMap;
import java.util.Map;

public class CloooudCustomerInterstitial extends WMCustomInterstitialAdapter {

    private boolean isReady = false;
    private AdView interstitialAd;

    @Override
    public void loadAd(Activity activity, Map<String, Object> serverExtra, Map<String, Object> map1) {
        String codeId = (String) map1.get(WMConstants.PLACEMENT_ID);//901121246
        AdRequestConfig requestConfig = new AdRequestConfig.Builder()
                .AdType(AdConfig.AD_TYPE_INTERSTITIAL)
                .slotId(codeId) //广告场景id
                .widthDp(300)
                .heightDp(300)
                .build();
        interstitialAd = new AdView(activity, requestConfig);
        interstitialAd.setListener(new AdViewListener() {
            @Override
            public void onAdClick() {
                callVideoAdClick();
            }

            @Override
            public void onAdFailed(String msg) {
                callLoadFail(new WMAdapterError(9999, msg));
            }

            @Override
            public void onAdReady(int price) {
                isReady = true;
                if (isClientBidding()) {
                    double ecpm = price;
                    if (ecpm < 0) {
                        ecpm = 0;
                    }
                    callLoadBiddingSuccess(new BidPrice(String.valueOf(ecpm)));
                } else {
                    callLoadSuccess();
                }
            }

            @Override
            public void onAdShow(CAdInfo cAdInfo) {
                callVideoAdShow();
            }

            @Override
            public void onAdDismissed(String s) {
                callVideoAdClosed();
            }
        });
    }

    public boolean isClientBidding() {
        return getBiddingType() == WMConstants.AD_TYPE_CLIENT_BIDING;
    }

    @Override
    public void showAd(Activity activity, HashMap<String, String> hashMap, Map<String, Object> map) {
        if (interstitialAd == null) {
            return;
        }
        interstitialAd.showInterstialAd(activity);
    }

    @Override
    public boolean isReady() {
        return isReady && interstitialAd != null;
    }

    @Override
    public void destroyAd() {
        if (interstitialAd == null) {
            return;
        }
        interstitialAd.onDestroyAd();
    }
}
