package com.example.tbadapter;

import android.app.Activity;
import android.util.Log;
import android.view.ViewGroup;
import android.widget.RelativeLayout;

import com.open.ad.polyunion.bean.CAdInfo;
import com.open.ad.polyunion.listener.AdViewListener;
import com.open.ad.polyunion.view.AdConfig;
import com.open.ad.polyunion.view.AdRequestConfig;
import com.open.ad.polyunion.view.AdView;
import com.windmill.sdk.WMConstants;
import com.windmill.sdk.base.WMAdapterError;
import com.windmill.sdk.custom.WMCustomSplashAdapter;
import com.windmill.sdk.models.BidPrice;

import java.util.Map;

public class CloooudCustomerSplash extends WMCustomSplashAdapter {
    private AdView splash;
    private boolean isReady = false;
    // 开屏广告视图父容器
    protected RelativeLayout mSplashRootContainer;

    @Override
    public void loadAd(Activity context, ViewGroup viewGroup, Map<String, Object> map, Map<String, Object> map1) {

        String codeId = (String) map1.get(WMConstants.PLACEMENT_ID);
        // 开屏广告则初始化视图容器
        mSplashRootContainer = new RelativeLayout(context.getApplicationContext());
        int[] screenSizeDP = Util.getScreenSizeInDP(context);
        AdRequestConfig requestConfig = new AdRequestConfig.Builder().AdType(AdConfig.AD_TYPE_SPLASH).requestTimeOutMillis(10000) //设置聚合SDK请求前超时时间，毫秒
                .AdType(AdConfig.AD_TYPE_SPLASH)
                .slotId(codeId) //广告场景id
                .widthDp(screenSizeDP[0]) //请求图片宽度dp值
                .heightDp(screenSizeDP[1]) //需要传广告展示的高度
                .splashContainer(mSplashRootContainer) //设置开屏广告view容器
                .requestTimeOutMillis(50000)
                .build();
        splash = new AdView((Activity) context, requestConfig);
        splash.setListener(new AdViewListener() {
            @Override
            public void onAdClick() {
                callSplashAdClick();
            }

            @Override
            public void onAdFailed(String msg) {
                callLoadFail(new WMAdapterError(9999, msg));
            }

            @Override
            public void onAdReady(int price) {
                isReady = true;
                if (isClientBidding()) {
                    double ecpm = price;
                    if (ecpm < 0) {
                        ecpm = 0;
                    }
                    callLoadBiddingSuccess(new BidPrice(String.valueOf(ecpm)));
                } else {
                    callLoadSuccess();
                }
            }

            @Override
            public void onAdShow(CAdInfo cAdInfo) {
                callSplashAdShow();
            }

            @Override
            public void onAdDismissed(String s) {
                callSplashAdSkipped();
                callSplashAdClosed();
            }
        });

    }

    public boolean isClientBidding() {
        return getBiddingType() == WMConstants.AD_TYPE_CLIENT_BIDING;
    }

    @Override
    public void showAd(Activity activity, ViewGroup viewGroup, Map<String, Object> map) {
        if (splash != null && viewGroup != null) {
            // 将SDK广告视图放入应用提供的容器
            RelativeLayout.LayoutParams lpRoot = new RelativeLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT);
            viewGroup.addView(mSplashRootContainer, lpRoot);
            splash.showSplashAd();
        }
    }

    @Override
    public boolean isReady() {
        return isReady && splash != null;
    }

    @Override
    public void destroyAd() {
        if (splash == null) {
            return;
        }
        splash.onDestroyAd();
    }
}
