package com.example.tbadapter.init;

import android.app.Application;
import android.content.Context;
import android.util.Log;

import com.open.ad.cloooud.api.listener.COaidProvider;
import com.open.ad.polyunion.newedition.contract.DeniedUpDeviceInfo;
import com.open.ad.polyunion.newedition.contract.InitSDKListener;
import com.open.ad.polyunion.view.AdConfig;
import com.open.ad.polyunion.view.AdView;
import com.open.ad.polyunion.view.InitSDKConfig;
import com.windmill.sdk.WMConstants;
import com.windmill.sdk.custom.WMCustomAdapterProxy;

import org.json.JSONObject;

import java.util.Map;

public class CloooudCustomInitLoader extends WMCustomAdapterProxy {
    @Override
    public void initializeADN(Context context, Map<String, Object> map) {
        try {
            String appCustomInfo = (String) map.get(WMConstants.CUSTOM_INFO);
            JSONObject object = new JSONObject(appCustomInfo);
            String appId = object.optString(WMConstants.APP_ID);
            String appName = object.optString(WMConstants.APP_NAME);
            InitSDKConfig initSDKConfig  = new InitSDKConfig.Builder()
                    .AppId(appId)
                    .appName(appName)//SDK后台注册的应用名称
                    // 竖屏 - AdConfig.REWARD_VIDEO_SCREEN_VERTICAL
                    // 横屏 - AdConfig.REWARD_VIDEO_SCREEN_x`HORIZONTAL
                    .RewardVideoScreenDirection(AdConfig.REWARD_VIDEO_SCREEN_VERTICAL) // 设置激励视频播放页面的横竖屏
                    .debug(false)////上线需要设置false
                    .setDeniedUpDeviceInfo(new DeniedUpDeviceInfo() {
                    })
                    .setOaidProvider(new COaidProvider() {
                        @Override
                        public String getOaid() {
                            return "";
                        }
                    }) //传入 OAID 获取器，建议集成 OAID SDK的应用设置
                    .build();
            AdView.initSDK((Application) context, initSDKConfig, new InitSDKListener() {
                @Override
                public void initializeSucceed() {
                    //初始化成功
                    callInitSuccess();
                }

                @Override
                public void initializeFail() {
                    //初始化失败
                    callInitFail(9999,"");
                }
            });
        }catch (Exception e){

        }

    }

    @Override public String getNetworkSdkVersion() {
        return AdView.getSDKVersion();
    }

    @Override
    public int baseOnToBidCustomAdapterVersion() {
        return  WMConstants.TO_BID_CUSTOM_ADAPTER_VERSION_2;
    }

    @Override
    public void notifyPrivacyStatusChange() {

    }
}
